[page:Loader] →

# [name]

A loader for loading a .prwm resource.
Packed Raw WebGL Model is an open-source binary file format for nD geometries specifically designed for JavaScript and WebGL with a strong focus on fast parsing (from 1ms to 0.1ms in Chrome 59 on a MBP Late 2013). The parsing of PRWM file is especially fast when the endianness of the file is the same as the endianness of the client platform. More information on this here.

## 代码示例

`// instantiate a loader const loader = new PRWMLoader(); // load a resource loader.load( // resource URL 'models/nefertiti.le.prwm', // called when resource is loaded function ( bufferGeometry ) { const object = new THREE.Mesh( bufferGeometry, new THREE.MeshNormalMaterial() ); scene.add( object ); }, // called when loading is in progresses function ( xhr ) { console.log( ( xhr.loaded / xhr.total * 100 ) + '% loaded' ); }, // called when loading has errors function ( error ) { console.log( 'An error happened' ); } );`

## 例子

[example:webgl_loader_prwm]

## Constructor

### [name]( [param:LoadingManager manager] )

[page:LoadingManager manager] — The [page:LoadingManager loadingManager] for the loader to use. Default is [page:LoadingManager THREE.DefaultLoadingManager].

Creates a new [name].

## Properties

See the base [page:Loader] class for common properties.

## Methods

See the base [page:Loader] class for common methods.

### [method:undefined load]( [param:String url], [param:Function onLoad], [param:Function onProgress], [param:Function onError] )

[page:String url] — A string containing the path/URL of the .prwm file. Any * character in the URL will be automatically replaced by le or be depending on the platform endianness.
[page:Function onLoad] — (optional) A function to be called after the loading is successfully completed. The function receives the loaded [page:BufferGeometry] as an argument.
[page:Function onProgress] — (optional) A function to be called while the loading is in progress. The function receives a XMLHttpRequest instance, which contains [page:Integer total] and [page:Integer loaded] bytes.
[page:Function onError] — (optional) A function to be called if an error occurs during loading. The function receives error as an argument.

Begin loading from url and call onLoad with the parsed response content.

### [method:BufferGeometry parse]( [param:ArrayBuffer arrayBuffer] )

[page:ArrayBuffer arrayBuffer] — ArrayBuffer containing the prwm data.

Parse a prwm file passed as an ArrayBuffer and directly return an instance of [page:BufferGeometry].

### PRWMLoader.isBigEndianPlatform( )

Return true if the endianness of the platform is Big Endian, false otherwise.

## Source

[link:https://github.com/mrdoob/three.js/blob/master/examples/jsm/loaders/PRWMLoader.js examples/jsm/loaders/PRWMLoader.js]